# Deep network: Network Class Reference

Network Class Reference

`#include <network.hpp>`

## Public Member Functions

void | compute_last_delta (Vector y)
| Network ()
void | set_cost (CostFunction)
void | push_layer (Layer::Layer &l)
void | is_done ()
Vector | feed_forward (Vector x_in)
Real | eval (Dataset *dataset)
void | train (Dataset *dataset, size_t nb_epochs, size_t batch_size, Real eta)

## Public Attributes

list< Layer::Layer * > | layers
size_t | n_in
size_t | n_out
Vector | a
Vector | last_delta
CostFunction | C

## Protected Member Functions

void | shuffle (size_t *tab, size_t size)
void | update_batch (Dataset *dataset, size_t *indices, size_t begin, size_t end, Real eta)
void | back_propagation (Vector x, Vector y, Real eta)

## Constructor & Destructor Documentation

## Network()

Network::Network | ( |  | ) |

## Member Function Documentation

## back_propagation()

void Network::back_propagation | ( | Vector | x,
|  | Vector | y,
|  | Real | eta
| ) |  |

protected

## compute_last_delta()

void Network::compute_last_delta | ( | Vector | y | ) |

## eval()

Real Network::eval | ( | Dataset * | dataset | ) |

## feed_forward()

Vector Network::feed_forward | ( | Vector | x_in | ) |

## is_done()

void Network::is_done | ( |  | ) |

## push_layer()

void Network::push_layer | ( | Layer::Layer & | l | ) |

## set_cost()

void Network::set_cost | ( | CostFunction | C_ | ) |

inline

## shuffle()

void Network::shuffle | ( | size_t * | tab,
|  | size_t | size
| ) |  |

protected

## train()

void Network::train | ( | Dataset * | dataset,
|  | size_t | nb_epochs,
|  | size_t | batch_size,
|  | Real | eta
| ) |  |

## update_batch()

void Network::update_batch | ( | Dataset * | dataset,
|  | size_t * | indices,
|  | size_t | begin,
|  | size_t | end,
|  | Real | eta
| ) |  |

protected

## Member Data Documentation

## a

Vector Network::a

## C

CostFunction Network::C

## last_delta

Vector Network::last_delta

## layers

list<Layer::Layer*> Network::layers

## n_in

size_t Network::n_in

## n_out

size_t Network::n_out

The documentation for this class was generated from the following files:

- src/network.hpp
- src/network.cpp